/*
Crearea si vizualizarea unei liste liniare cu inserare in fata.
Cautarea, stergerea unui element cu o cheie data.
*/

#include <stdio.h>
#include <stdlib.h>  /*pt functia malloc*/
#include <ctype.h>   /*pt functia toupper*/

typedef struct nod 
{
	int cheie;       /*cheia dupa care are loc identificarea nodurilor in cadrul listei*/
	char info[10];   /*informatia utila din cadrul listei*/
	struct nod *urm; /*un pointer catre urmatorul nod din lista*/
}Tnod;
typedef Tnod* ref;   /*referinta catre o structura de tipul Tnod*/

ref p=NULL, q=NULL, r=NULL; /*p - pointer catre primul nod din lista
							  q - pointer catre ultimul nod din lista
							  r - pointer auxiliar*/
unsigned int dinamic=0; /*controleaza meniul ce se afiseaza*/

void meniu(void);
void ins_fata(void);
void listare(void);
void creare(void);
void delete_nod(int);
int cautare(int);
void delete_lista(void);
void listare2(ref);

main()
{
	char c;

	printf("Crearea si vizualizarea unei liste liniare cu inserare in spate.\n");
	printf("        Cautarea, stergerea unui element cu o cheie data.\n");
	do
	{
		meniu(); fflush(stdin); scanf("%c", &c); c = toupper(c);
		switch(c)
		{
			int cheie;

		case 'C':
			creare();
			dinamic = 1;
			break;
		case 'L':
			listare();
			break;
		case 'A':
			listare2(p);
			break;
		case 'D':
			printf("Introduceti cheia nodului ce doriti sa-l stergeti : ");
			fflush(stdin); scanf("%d", &cheie);
			delete_nod(cheie);
			break;
		case 'I':
			ins_fata();
			break;
		case 'S':
			printf("Introduceti cheia nodului ce doriti sa-l cautati : ");
			fflush(stdin); scanf("%d", &cheie);
			if(cautare(cheie)==1)
				printf("Informatia din nodul cu cheia \"%d\" este : %s\n", cheie, r->info);
			else 
				printf("Nu exista nici un nod cu cheia \"%d\" !\n", cheie);
			break;
		case 'V':
			delete_lista();
			printf("Spatiul ocupat de l.l.s.i a fost eliberat!\n");
			dinamic = 0;
			break;
		default:
			printf("Comanda gresita!\n");
		}
	}
	while(c!='E');	
	delete_lista();
	printf("Spatiul ocupat de l.l.s.i. a fost eliberat\n");
}

void creare() /*Creaza o l.l.s.i. prin apeluri succesive ale functiei ins_fata*/
{
	char c;

	do
	{
		ins_fata();
		printf("Continuati(D/N) : ");
		fflush(stdin); scanf("%c", &c); c = toupper(c);
	}
	while(c=='D');
}/*sfarsit creare*/

void ins_fata(void)  /*insereaza un nod in fata unei l.l.s.i.*/
{
	r = (ref)malloc(sizeof(Tnod));
	printf("Introduceti cheia nodului : "); 
	fflush(stdin); scanf("%d", &r->cheie); /*de adaugat validarea cheii*/
	printf("Introduceti informatia utila : ");
	fflush(stdin); scanf("%s", r->info);
	r->urm = p;
	p = r;
}/*sfarsit ins_fata*/

void listare(void) /*listeaza elementele l.l.s.i. cu inserare in fata*/
{
	if(p==NULL)
		printf("Lista este vida!\n");
	else
	{
		printf("Elementele listei sunt :\n");
		r = p;
		while(r!=NULL)
		{
			printf("Cheia = %d        ", r->cheie);
			printf("Informatia = %s", r->info);
			printf("\n");
			r = r->urm; 
		}
	}
}/*sfarsit listare*/

void listare2(ref r)
{
	if(r!=NULL)
	{
		listare2(r->urm);
		printf("Cheia = %d        ", r->cheie);
		printf("Informatia = %s\n", r->info);
	}
}

int cautare(int k) /*cauta nodul cu cheia k*/
{
	r = p;
	while((r!=NULL) && (r->cheie!=k))
		r = r->urm;
	if(r==NULL)
		return -1; /*returneaza -1 daca nu a gasit un nod cu cheia k*/
	else 
		return 1; /*returneaza 1 daca a gasit un nod cu cheia k*/
}/*sfarsit cautare*/

void delete_nod(int k) /*sterge nodul cu cheia k*/
{
	if(p->cheie == k)
	{
		r = p->urm;
		free(p);
		p = r;
		printf("Nodul cu cheia \"%d\" a fost sters.\n", k);
		if(p==NULL)
		{
			dinamic = 0;
			printf("Lista este vida.\n");
		}
	}
	else
	{
		r = p;
		q = p;
		while((r!=NULL) && (r->cheie!=k))
		{
			q = r;
			r = r->urm;
		}
		if(r!=NULL)
		{
			q->urm = r->urm;
			free(r);
			r = NULL;
			printf("Nodul cu cheia \"%d\" a fost sters\n", k);
		}
		else 
			printf("Nu exista nici un nod cu cheia \"%d\"\n", k);
	}
}/*sfarsit delete_nod*/

void delete_lista(void) /*sterge lista liniara <=> elibereaza spatiul ocupat*/
{
	for(r = p; r != NULL; r = q)
	{
		q = r->urm;
		free(r);
		r = NULL;
	}
	p = NULL;
} /*sfarsit delete_lista*/

void meniu(void)
{	
	printf("\nL.l.s.i. cu inserarea elementelor la sfarsitul listei\n\n");
	if(dinamic==0)
		printf("C. Crearea listei\n");
	if(dinamic)
	{
		printf("I. Inserarea unui element la sfarsitul listei\n");
		printf("S. Cauta un element dupa o cheie data\n");
		printf("D. Sterge un element cu o cheie data\n");
		printf("V. Sterge l.l.s.i.\n");
		printf("L. Afiseaza lista liniara\n");
		printf("A. Listeaza lista liniara in ordinea introducerii\n");
	}
	printf("E. Exit\n");
	printf("Tastati optiunea : ");
}